<organisation-details class=details>

  <header class={ row: true, deleted: this.deleted }>
    <div>
      <div class="avatar">
          <icon figure=placeholder-organisation />
      </div>
    </div>

    <div>
      <h1>{ this.organisation.name } <small if={ this.organisation.acronym }>( { this.organisation.acronym } )</small><add-export organisation-pk={ this.organisation.pk } /></h1>
      <h2 if={ this.organisation.kind || this.organisation.keywords.length }>
        <tag type=kind label={ this.kind } />
        <tag each={ kw in this.organisation.keywords } type=keyword label={ kw.label } value={ kw.pk } />
      </h2>

      <div class=row>
        <div>
          <ul>
            <li if={ this.organisation.address || this.organisation.postcode || this.organisation.city || this.organisation.country } class="row">
              <icon figure=address />
              <div>
                <div if={ this.organisation.address }>{ this.organisation.address }</div>
                <span if={ this.organisation.postcode }>{ this.organisation.postcode } </span>
                <span if={ this.organisation.city }> { this.organisation.city } </span>
                <span if={ this.organisation.country }>({ getCountry(this.organisation.country).label })</span>
              </div>
            </li>
            <li if={ this.organisation.email }><icon figure=email /><a target=_blank href="mailto:{ this.organisation.name }<{ this.organisation.email }>">{ this.organisation.email }</a></li>
            <li if={ this.organisation.website }><icon figure=web /><a href={ this.organisation.website } target=_blank>{ this.organisation.website }</a></li>
            <li if={ this.organisation.phone }><icon figure=landline />{ this.organisation.phone }</li>
            <li if={ this.organisation.cell_phone }><icon figure=phone />{ this.organisation.cell_phone }</li>
            <li if={ this.membersCount }><icon figure=membership /><a href={location.pathname}?resource=organisation&membership={ this.organisation.pk }|{ this.organisation.label }>{ this.membersCount } members</a></li>
            <li if={ this.votingContact }><icon figure=votingcontact /><a href=/person/{this.votingContact.person.pk }>{ this.votingContact.person.label }</a></li>
          </ul>
        </div>

        <div>
          <div if={ this.organisation.groupings && this.organisation.groupings.length } class=grouping>
            <grouping-tag each={ grouping in this.opts.organisation.groupings } value={ grouping } />
          </div>
          <div if={ this.diseases.length <= 3 } class="diseases-list compact">
            <tag each={ disease in this.diseases } type=disease label="{ disease.name }" external-url="https://www.orpha.net/consor/cgi-bin/OC_Exp.php?Expert={ disease.pk }" external-title="View details on Orphanet" value={ disease.pk } details-link=/disease/{ disease.pk } />
          </div>
        </div>
      </div>
    </div>
  </header>

  <section if={ this.diseases.length > 3 } class="diseases-list">
    <div>
      <h2 class=disease>Diseases</h2>
      <expandable-list items={ this.diseases }>
        <yield>
          <tag each={ disease in this.opts.items.slice(0, this.slice) } type=disease label="{ disease.name }" external-url="https://www.orpha.net/consor/cgi-bin/OC_Exp.php?Expert={ disease.pk }" external-title="View details on Orphanet" value={ disease.pk } details-link=/disease/{ disease.pk } />
        </yield>
      </expandable-list>
    </div>
  </section>

  <section if={ this.organisation.membership.length }>
    <div>
      <h2 class=membership>Memberships</h2>
      <ul>
        <li each={ membership in this.activeMemberships }>
          <a href=/organisation/{ membership.organisation.pk }>{ membership.organisation.label }</a><span if={ membership.status }>&nbsp;({ keyToValue(this.membershipStatuses, membership.status) })</span>
          <span if={ membership.start_date } class=from-date>&nbsp;From { trans(new Date(membership.start_date)) }</span>

          <membership-fees fees={ membership.fees } />
        </li>
      </ul>

      <virtual if={ this.previousMemberships.length }>
      <details>
        <summary>Previous memberships ({ this.previousMemberships.length })</summary>
        <table>
          <tr each={ membership in this.previousMemberships }>
            <td>
              { membership.organisation.label }
              <span if={ membership.status }>({ keyToValue(this.membershipStatuses, membership.status) })</span>
              <membership-fees fees={ membership.fees } />
            </td>
            <td>
              <span if={ membership.start_date }>From { trans(new Date(membership.start_date)) }</span>
              <span if={ membership.end_date }> until { trans(new Date(membership.end_date)) }</span>
            </td>
            <td>
            </td>
          </tr>
        </table>
      </details>
    </div>
  </section>

  <section if={ this.organisation.roles && this.organisation.roles.length }>
    <div>
      <div class="contact-header">
        <h2>Contacts</h2>
        <add-export roles={ this.organisation.roles } />
      </div>
      <table>
        <tr>
          <th>Name</th>
          <th>Position</th>
          <th>Actions</th>
        </tr>
        <tr each={ role in this.organisation.roles }>
          <td class="role-name-data">
            <icon figure={ role.is_primary ? 'primary' : 'person' } />
            <country-flag country={ role.person.country } />
            <a href=/person/{ role.person.pk }/{ location.search } title="View profile in details">
              { role.person.first_name } { role.person.last_name }
            </a>
          </td>
          <td>
            { role.name }
          </td>
          <td>
            <add-export person-pk={ role.person.pk } organisation-pk={ this.opts.organisation.pk } />
            <a class=email if={ role.email || role.person.email || this.organisation.email } target=_blank href="mailto:{ role.person.label }<{ role.email || role.person.email || this.organisation.email }>" title="Send an email"><icon figure=email></icon></a>
          </td>
        </tr>
      </table>
    </div>
  </section>

  <section class=property-group if={ this.groupsCount }>
    <div>
      <h2 class=group>Groups</h2>
      <div each={ role in this.organisation.roles } if={ role.activeGroups.length || role.inactiveGroups.length }
           class="item">
        <h3>{ role.person.label }</h3>
        <div class=active if={ role.activeGroups.length }>
          Active:
          <p each={ group in role.activeGroups }>
            <a href=/?group={ group.group.pk }|{ group.group.label } title={ group.group.description }>
                <icon figure=group></icon>
                { group.group.label }
            </a>
              <span if={ group.role }> { group.role }</span>
          </p>
        </div>
        <div class=inactive if={ role.inactiveGroups.length }>
          Inactive:
          <p each={ group in role.inactiveGroups }>
            <a href=/?group={ group.group.pk }|{ group.group.label } title={ group.group.description }>
                <icon figure=group></icon>{ group.group.label }</a>
              <span if={ group.role }> { group.role }</span>
          </p>
        </div>
      <div>
    </div>
  </section>

  <section  if={ this.organisation.adherents || this.organisation.budget || this.organisation.creation_year || this.organisation.board || this.organisation.paid_staff || this.organisation.pharma_funding }>
    <div>
      <h2>Patient Organisation Details</h2>
      <p>
        <virtual if={ this.organisation.adherents }>{ this.organisation.adherents } members, </virtual>
        <virtual if={ this.organisation.budget }>annual budget of { Number(this.organisation.budget).toLocaleString() }€, </virtual>
        <virtual if={ this.organisation.creation_year }>since { this.organisation.creation_year }</virtual>
      </p>
      <p>
        <virtual if={ this.organisation.board }>{ this.organisation.board } patient representative vs board director, </virtual>
        <virtual if={ this.organisation.paid_staff }>paid staff: { Number(this.organisation.paid_staff) }, </virtual>
        <virtual if={ this.organisation.pharma_funding }> { this.organisation.pharma_funding }% funded by pharma.</virtual>
      </p>
    </div>
  </section>

  <section if={ this.organisation.attachments.length }>
    <div>
      <h2>Documents</h2>
      <div each={ attachment in this.organisation.attachments }>
        <attachment-link contact-id={ this.organisation.pk } attachment={ attachment } />
      </div>
    </div>
  </section>

  <section if={ this.organisation.comment }>
    <div>
      <h2>Comments</h2>
      <p>
        <raw html={ this.organisation.comment.replace(/\n/g, '<br>' ) } />
      </p>
    </div>
  </section>

  <diffs if={ this.opts.diffs } diffs={ this.opts.diffs } />

  <section class=toolbar>
    <small>
        id: { this.organisation.pk } <span if={ this.organisation.filemaker_pk }>(previously {this.organisation.filemaker_pk})</span>
        <p>
        Created on { trans(new Date(this.organisation.created_at)) }
        <virtual if={ this.organisation.created_by }> by
          <a href=/person/{ this.organisation.created_by.pk }>
            { this.organisation.created_by.first_name } { this.organisation.created_by.last_name }
          </a>
        </virtual>
      </p>
      <p>
        Modified on { trans(new Date(this.organisation.modified_at)) }
        <virtual if={ this.organisation.modified_by }> by
          <a href=/person/{ this.organisation.modified_by.pk }>
            { this.organisation.modified_by.first_name } { this.organisation.modified_by.last_name }
          </a>
        </virtual>
      </p>
      <a href="{ getUrl('/organisation/' + this.opts.organisation.pk + '/history') }">Blame who messed with this</a>
    </small>
    <div>
        <a class=button if={ this.hasFees } href={
          getUrl('/organisation/'+this.opts.organisation.pk+'/edit/fees') } style="margin-right: .8rem">
          <icon figure=fees-small embedded />Edit Fees
        </a>
        <a href=/organisation/{ this.opts.organisation.pk }/edit/{ location.search } class="button"><icon figure=edit embedded /> Edit this organisation</a>
    </div>
  </section>

  <script>
    this.organisation = {}
    this.diseases = []
    this.deleted = false
    this.membershipStatuses = config.MEMBERSHIP_STATUSES
    this.membersCount = 0

    function isActiveMembership(membership) {
      return !membership.end_date && membership.status !== 'w'
    }

    this.on('*', async () => {
      const hasChanged = this.organisation !== this.opts.organisation
      this.organisation = this.opts.organisation
      this.diseases = this.organisation.diseases.sort((a,b) => a.name > b.name ? 1 : -1)
      this.deleted = this.organisation.keywords.find(k => k.name.toLowerCase() === 'to be deleted')
      this.organisation.keywords = this.organisation.keywords.sort((k1, k2) => k1.label.toLowerCase() < k2.label.toLowerCase() ? -1 : 1)


      this.activeMemberships = this.organisation.membership.filter(isActiveMembership)
      this.previousMemberships = this.organisation.membership.filter(m => !isActiveMembership(m))
      this.kind = keyToValue(config.ORGANISATION_KIND, this.organisation.kind)
      this.hasFees = this.organisation.membership.find(o => o.organisation.pk == config.EURORDIS_ORGANISATION.pk)
      this.groupsCount = this.organisation.roles.reduce((total, role) => total += role.groups.length, 0)
      this.votingContact = this.organisation.roles.find(r => r.is_voting)
      this.organisation.roles = this.organisation.roles.map(role => {
        role.activeGroups = role.groups.filter(g => g.is_active)
        role.inactiveGroups = role.groups.filter(g => !g.is_active)
        return role
      })

      if(hasChanged) {
        const response = apiResponse(await api(`/search?resource=organisation&membership=${this.organisation.pk}`))
        this.membersCount = response.data.total
        this.update()
      }
    })
  </script>

  <link rel="stylesheet" href="/src/css/details.css">

  <style>

    :scope [figure=person] img,
    :scope country-flag img {
      width: 1.2rem;
    }
    :scope [figure=basket] img {
      width: 1.2rem;
    }

    :scope [figure=person],
    :scope [figure=primary] {
      margin-right: .3rem;
    }
    :scope country-flag {
      margin-right: .4rem;
    }

    :scope h2 tag {
      margin-right: 1.2rem;
    }

    :scope h1 small {
      font-size: 0.9rem;
      color: var(--text-color);
    }

    :scope h1 > * {
      margin-top: .4rem;
      margin-left: .2rem;
    }

    .email icon {
      height: 1rem;
      margin-left: .5rem;
    }

    table {
      width: 100%;
    }
    table a {
      border-bottom: none;
    }
    th {
      text-align: left;
      color: rgba(80,80,110,0.6);
      font-weight: normal;
    }
    /* td:last-child {
      padding-left: 1rem;
    } */
    td:last-child a {
      padding: 0;
    }
    td:last-child a:hover {
      background: none;
    }

    .grouping {
      margin-top: .4rem;
    }

    .membership + ul li {
      display: block;
    }

    membership-fees summary + ul {
      display: flex;
      flex-wrap: wrap
    }
    membership-fees summary + ul li {
      flex-basis: 33%
    }

    .from-date {
      margin-left: 0.4rem;
      color: #696E8C;
    }

    .deleted *,
    .deleted ~ * * {
      opacity: .8;
    }

    .deleted h1 {
      text-decoration: line-through;
    }

    .role-name-data {
      display: flex;
      align-items: center;
    }

    :scope .contact-header {
      display: flex;
      align-items: center;
      margin-bottom: .8rem;
    }
    :scope section .contact-header h2 {
      margin-bottom: 0;
    }

    :scope .contact-header add-export {
      display: flex;
      align-items: center;
      margin-left: 0.5rem;
    }

    .diseases-list {
      max-width: 100rem;
    }
    tag[type=disease] {
      /* Override main css for alignement of disease card when > 3 */
      margin-left: 0 !important;
      margin-right: 5%;
      width: 45%;
    }
    .diseases-list.compact tag[type=disease] {
      width: 100%;
    }

    .toolbar > div {
        display: flex;
    }
  </style>
</organisation-details>
